#include "Main.h"


char CList[] = "XP2LINE\0XP2PENT\0XP2NOTE\0XP2COLORCIRCLE\0\0";
PCMDPROC PList[] = { About, XP2Line, XP2Pent, XP2Note, XP2ColorCircle };

XP MyXP = { 0, CList, PList, 0, 0, 0, XPID, 0, 620, 0, 0, 620 };


/////////////  DllMain - XP initialization & Unload code //////////////
BOOL WINAPI DllMain(const HINSTANCE hDLL, const DWORD dwReason, LPVOID lpReserved) {
	UNREFERENCED_PARAMETER(lpReserved);

	switch (dwReason)
	{
	case DLL_PROCESS_ATTACH:
		MyXP.ModHdl = hDLL;
		_XPRegCmd(&MyXP);
		break;
	case DLL_PROCESS_DETACH:
		_XPUnregCmd(&MyXP);
		break;
	default:
		break;
	}
	return TRUE;
}


void XPCALL About() {

	FORMST(MyAPkt, "CC3+ XP Template 2022\n\n"
		"About box for CC3+ XP Template 2022"
	)

	FormSt(&MyAPkt, RSC(FD_MsgBox));
	CmdEnd();
}

LINE2 XPLine = { sizeof(LINE2), ET_LINE2, 0, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0.0, 0,
				0.0, 0.0, 1.0, 1.0 };

FORMST(lpszStart, "Line Start:\0")
FORMST(lpszEnd, "Line End:\0")

RDATA P1Req =
{ sizeof(RDATA), RD_2DC, NULL, RDF_C, (DWORD*)&XPLine.Line.p1,
  (DWORD*)&lpszStart,RDC_XH, XP2LineP1, NULL, NULL, 0, NULL, 0 };

RDATA P2Req =
{ sizeof(RDATA), RD_2DC, NULL, RDF_C, (DWORD*)&XPLine.Line.p2,
  (DWORD*)&lpszEnd,RDC_RBAND, XP2LineP2, NULL, NULL, 0, NULL, 0 };

void XPCALL XP2Line() {

	ReqData(&P1Req);

}

void XPCALL XP2LineP1(int Result, int Result2, int Result3) {
	if (Result != X_OK) { CmdEnd(); return; }
	NewCsrOrg(XPLine.Line.p1.x, XPLine.Line.p1.y);
	ReqData(&P2Req);
}

void XPCALL XP2LineP2(int Result, int Result2, int Result3) {

	if (Result != X_OK) { CmdEnd(); return; }
	GetCStuff(&XPLine.CStuff);
	MarkUndoAdd();
	pENTREC pEntRec = DLApnd(NULL, (pENTREC)&XPLine);
	EDraw(pEntRec);

	CmdEnd();
}

GPOINT2 p1;
GPOINT2 p2;

FORMST(lpszCenter, "Center of Pentagram:\0")
FORMST(lpszEdge, "Edge of Pentagram:\0")

RDATA Pent1Req =
{ sizeof(RDATA), RD_2DC, NULL, RDF_C, (DWORD*)&p1,
  (DWORD*)&lpszCenter,RDC_XH, XP2PentP1, NULL, NULL, 0, NULL, 0 };

RDATA Pent2Req =
{ sizeof(RDATA), RD_2DC, NULL, RDF_C, (DWORD*)&p2,
  (DWORD*)&lpszEdge,RDC_RBAND, XP2PentP2, NULL, NULL, 0, NULL, 0 };

void XPCALL XP2Pent() {

	ReqData(&Pent1Req);

}

void XPCALL XP2PentP1(int Result, int Result2, int Result3) {

	if (Result != X_OK) { CmdEnd(); return; }
	NewCsrOrg(p1.x, p1.y);
	ReqData(&Pent2Req);

}

void XPCALL XP2PentP2(int Result, int Result2, int Result3) {

	if (Result != X_OK) { CmdEnd(); return; }
	MarkUndoAdd();

	LINE2 l = { {sizeof(LINE2), ET_LINE2, 0, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0.0, 0},
			0.0, 0.0, 1.0, 1.0 };
	GetCStuff(&l.CStuff);

	l.Line.p1 = p1;
	l.Line.p2 = p2;

	float x = p1.x;
	float y = p1.y;

	pENTREC pEntRec = DLApnd(NULL, (pENTREC)&l);
	EDraw(pEntRec);

	for (int i = 0; i < 4; i++) {

		pEntRec = DLCopy(NULL, pEntRec);
		GetCStuff(pEntRec);
		CTMI2();
		CTMT2(-l.Line.p1.x, -l.Line.p1.y);
		CTMR2(144.0 * M_PI / 180);
		CTMT2(l.Line.p2.x, l.Line.p2.y);

		ETran(pEntRec);
		EDraw(pEntRec);

		x += pEntRec->Line.Line.p1.x;
		y += pEntRec->Line.Line.p1.y;

	}

	CIR2 c = { {sizeof(CIR2), ET_CIR2, 0, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0.0, 0},
	0.0, 0.0, 1.0, };
	GetCStuff(&c.CStuff);
	c.Circle.Center.x = x / 5;
	c.Circle.Center.y = y / 5;
	c.Circle.Radius =
		(float)(sqrt (pow((double)p2.x - (double)pEntRec->Line.Line.p1.x, 2) +
			pow((double)p2.y - (double)pEntRec->Line.Line.p1.y, 2)) / sqrt((5 - sqrt(5)) / 2));

	if (c.CStuff.LWidth == 0.0f) {
		c.CStuff.EFStyle = 0;
	}

	pEntRec = DLApnd(NULL, (pENTREC)&c);
	EDraw(pEntRec);

	CmdEnd();

}

char noteTitle[32];
char cmdLineBuffer[257];
char noteContent[8500];

FORMST(lpszTitle, "Note Title:\0")
FORMST(lpszContent, "Note Content:\0")

RDATA Note1Req =
{ sizeof(RDATA), RD_TxWord, NULL, RDF_C + RDF_SPACEOK, (DWORD*)&cmdLineBuffer,
  (DWORD*)&lpszTitle,RDC_NONE, XP2NoteTitle, NULL, NULL, 0, NULL, 0 };

RDATA Note2Req =
{ sizeof(RDATA), RD_TxWord, NULL, RDF_C + RDF_SPACEOK, (DWORD*)&cmdLineBuffer,
  (DWORD*)&lpszContent,RDC_NONE, XP2NoteContent, NULL, NULL, 0, NULL, 0 };


void XPCALL XP2Note(void) {

	ReqData(&Note1Req);

}

void XPCALL XP2NoteTitle(int Result, int Result2, int Result3) {

	if (Result != X_OK) { CmdEnd(); return; }

	cmdLineBuffer[31] = '\0';
	strcpy_s(noteTitle, cmdLineBuffer);

	ReqData(&Note2Req);

}

void XPCALL XP2NoteContent(int Result, int Result2, int Result3) {

	if (Result == X_OK) {

		if (strlen(noteContent) >= 1) {
			std::string buffer = std::string(noteContent) +
				"\r\n" + std::string(cmdLineBuffer);
			strcpy_s(noteContent, buffer.c_str());
		}
		else {
			strcpy_s(noteContent, cmdLineBuffer);
		}

		if (strlen(noteContent) < 8192) {
			ReqData(&Note2Req);
		}
		else {
			XP2NoteContent(X_DFLT, 0, 0);
		}

	}
	else if (Result == X_DFLT) {

		noteContent[8191] = '\0';

		const auto len = static_cast<int>(strlen(noteContent) + sizeof(NOTE));
		std::vector<char> buffer(len);
		auto p = reinterpret_cast<pENTREC>(buffer.data());

		p->CStuff = { len, ET_NOTE, 0, 0 , 0, 0, 0, 0, 0, 0, 0, 0, 0 };

		strncpy_s(p->Note.NName, noteTitle, 32);

#pragma warning(disable:4996)
		strncpy(p->Note.NData, noteContent, min(strlen(noteContent), 8192));


		GetCStuff(p);

		DLApnd(NULL, p);
		CmdEnd();

	}
	else {

		CmdEnd();
	}

}

FORMST(lpszColor, "New Circle Color Base [Palette]:\0")
int color;

RDATA ColorReq =
{ sizeof(RDATA), RD_Color, NULL, RDF_C, (DWORD*)&color,
  (DWORD*)&lpszColor,RDC_ARROW, XP2ColorCircleColor, NULL, NULL, 0, NULL, 0 };


void XPCALL XP2ColorCircle() {

	ReqData(&ColorReq);

}

void XPCALL XP2ColorCircleColor(int Result, int Result2, int Result3) {

	if (Result != X_OK) { CmdEnd(); }

	DLScan(NULL, XP2ColorCircleProcess, DLS_Std, NULL, NULL);

	CmdEnd();

}

pENTREC XPCALL XP2ColorCircleProcess(void* hDList, const pENTREC pEntRec, const DWORD parm1, DWORD parm2) {

	UNREFERENCED_PARAMETER(parm1);
	UNREFERENCED_PARAMETER(parm2);
	UNREFERENCED_PARAMETER(hDList);

	const auto circle = XP_CIR2_CAST(pEntRec);

	if (circle) {

		circle->CStuff.EColor2 = (color %= 255)++;
		EDraw(pEntRec);

	}

	return 0;
}
